Index: www/typo3_src/typo3/sysext/fluid/Classes/ViewHelpers/Form/UploadViewHelper.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- www/typo3_src/typo3/sysext/fluid/Classes/ViewHelpers/Form/UploadViewHelper.php	(revision )
+++ www/typo3_src/typo3/sysext/fluid/Classes/ViewHelpers/Form/UploadViewHelper.php	(revision )
@@ -1,25 +1,25 @@
 <?php
 namespace TYPO3\CMS\Fluid\ViewHelpers\Form;
 
-/*                                                                        *
- * This script is backported from the TYPO3 Flow package "TYPO3.Fluid".   *
- *                                                                        *
- * It is free software; you can redistribute it and/or modify it under    *
- * the terms of the GNU Lesser General Public License, either version 3   *
- *  of the License, or (at your option) any later version.                *
- *                                                                        *
- *                                                                        *
- * This script is distributed in the hope that it will be useful, but     *
- * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHAN-    *
- * TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser       *
- * General Public License for more details.                               *
- *                                                                        *
- * You should have received a copy of the GNU Lesser General Public       *
- * License along with the script.                                         *
- * If not, see http://www.gnu.org/licenses/lgpl.html                      *
- *                                                                        *
- * The TYPO3 project - inspiring people to share!                         *
- *                                                                        */
+    /*                                                                        *
+     * This script is backported from the TYPO3 Flow package "TYPO3.Fluid".   *
+     *                                                                        *
+     * It is free software; you can redistribute it and/or modify it under    *
+     * the terms of the GNU Lesser General Public License, either version 3   *
+     *  of the License, or (at your option) any later version.                *
+     *                                                                        *
+     *                                                                        *
+     * This script is distributed in the hope that it will be useful, but     *
+     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHAN-    *
+     * TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser       *
+     * General Public License for more details.                               *
+     *                                                                        *
+     * You should have received a copy of the GNU Lesser General Public       *
+     * License along with the script.                                         *
+     * If not, see http://www.gnu.org/licenses/lgpl.html                      *
+     *                                                                        *
+     * The TYPO3 project - inspiring people to share!                         *
+     *                                                                        */
 /**
  * A view helper which generates an <input type="file"> HTML element.
  * Make sure to set enctype="multipart/form-data" on the form!
@@ -53,6 +53,7 @@
         parent::initializeArguments();
         $this->registerTagAttribute('disabled', 'string', 'Specifies that the input element should be disabled when the page loads');
         $this->registerTagAttribute('multiple', 'string', 'Specifies that the file input element should allow multiple selection of files');
+        $this->registerTagAttribute('accept', 'string', 'Specifies the types of files that the server accepts');
         $this->registerArgument('errorClass', 'string', 'CSS class to set if there are errors for this view helper', false, 'f3-form-error');
         $this->registerUniversalTagAttributes();
     }