From 55dc014f99d80ddfe276467cb0bae7fbf56261e6 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Gunter=20K=C3=B6nigsmann?= <gunter@peterpall.de>
Date: Sat, 7 May 2016 11:24:16 +0200
Subject: [PATCH] Add flac, ogg and opus to the default media extensions.

---
 typo3/sysext/core/Classes/Imaging/IconRegistry.php       | 3 +++
 typo3/sysext/core/Configuration/DefaultConfiguration.php | 2 +-
 typo3/sysext/t3editor/Resources/Private/tsref.xml        | 2 +-
 3 files changed, 5 insertions(+), 2 deletions(-)

diff --git a/typo3/sysext/core/Classes/Imaging/IconRegistry.php b/typo3/sysext/core/Classes/Imaging/IconRegistry.php
index 3725aad..9c7e665 100644
--- a/typo3/sysext/core/Classes/Imaging/IconRegistry.php
+++ b/typo3/sysext/core/Classes/Imaging/IconRegistry.php
@@ -2582,6 +2582,9 @@ class IconRegistry implements SingletonInterface
         'youtube' => 'mimetypes-media-video-youtube',
         'wav' => 'mimetypes-media-audio',
         'mp3' => 'mimetypes-media-audio',
+        'ogg' => 'mimetypes-media-audio',
+        'flac' => 'mimetypes-media-audio',
+        'opus' => 'mimetypes-media-audio',
         'mid' => 'mimetypes-media-audio',
         'swf' => 'mimetypes-media-flash',
         'swa' => 'mimetypes-media-flash',
diff --git a/typo3/sysext/core/Configuration/DefaultConfiguration.php b/typo3/sysext/core/Configuration/DefaultConfiguration.php
index ea2057f..8591856 100644
--- a/typo3/sysext/core/Configuration/DefaultConfiguration.php
+++ b/typo3/sysext/core/Configuration/DefaultConfiguration.php
@@ -70,7 +70,7 @@ return array(
         'loginCopyrightWarrantyProvider' => '',    // String: If you provide warranty for TYPO3 to your customers insert you (company) name here. It will appear in the login-dialog as the warranty provider. (You must also set URL below).
         'loginCopyrightWarrantyURL' => '',        // String: Add the URL where you explain the extend of the warranty you provide. This URL is displayed in the login dialog as the place where people can learn more about the conditions of your warranty. Must be set (more than 10 chars) in addition with the 'loginCopyrightWarrantyProvider' message.
         'textfile_ext' => 'txt,ts,typoscript,html,htm,css,tmpl,js,sql,xml,csv,xlf',    // Text file extensions. Those that can be edited. Executable PHP files may not be editable in webspace if disallowed!
-        'mediafile_ext' => 'gif,jpg,jpeg,bmp,png,pdf,svg,ai,mp3,wav,mp4,webm,youtube,vimeo',    // Commalist of file extensions perceived as media files by TYPO3. Lowercase and no spaces between!
+        'mediafile_ext' => 'gif,jpg,jpeg,bmp,png,pdf,svg,ai,mp3,wav,mp4,ogg,flac,opus,webm,youtube,vimeo',    // Commalist of file extensions perceived as media files by TYPO3. Lowercase and no spaces between!
         'binPath' => '',                        // String: List of absolute paths where external programs should be searched for. Eg. <code>/usr/local/webbin/,/home/xyz/bin/</code>. (ImageMagick path have to be configured separately)
         'binSetup' => '',                        // String (textarea): List of programs (separated by newline or comma). By default programs will be searched in default paths and the special paths defined by 'binPath'. When PHP has openbasedir enabled the programs can not be found and have to be configured here. Example: <code>perl=/usr/bin/perl,unzip=/usr/local/bin/unzip</code>
         'no_pconnect' => true,                    // Boolean: If TRUE, "connect" is used to connect to the database. If FALSE, a persistent connection using "pconnect" will be established!
diff --git a/typo3/sysext/t3editor/Resources/Private/tsref.xml b/typo3/sysext/t3editor/Resources/Private/tsref.xml
index 849d675..37a64f6 100644
--- a/typo3/sysext/t3editor/Resources/Private/tsref.xml
+++ b/typo3/sysext/t3editor/Resources/Private/tsref.xml
@@ -5154,7 +5154,7 @@ txt, html, htm:Inserted directly
 class:Java-applet
 swf:Flash animation
 swa, dcr:ShockWave Animation
-wav,au:Sound
+wav,au,ogg,opus,flac:Sound
 avi,mov,asf,mpg,wmv:Movies (AVI, QuickTime, MPEG4)]]></description>
 			<default><![CDATA[
 ]]></default>
-- 
2.8.1