diff -ur private/typo3/sysext/extbase/Classes/Persistence/Generic/PersistenceManager.php patches/extbase/Classes/Persistence/Generic/PersistenceManager.php
--- private/typo3/sysext/extbase/Classes/Persistence/Generic/PersistenceManager.php	2020-07-07 12:02:44.000000000 +0200
+++ patches/extbase/Classes/Persistence/Generic/PersistenceManager.php	2020-07-15 16:19:06.736365290 +0200
@@ -175,12 +175,13 @@
      * Return a query object for the given type.
      *
      * @param string $type
+     * @param null|QuerySettingsInterface $defaultQuerySettings
      * @return QueryInterface
      * @internal only to be used within Extbase, not part of TYPO3 Core API.
      */
-    public function createQueryForType($type)
+    public function createQueryForType($type, $defaultQuerySettings = null)
     {
-        return $this->queryFactory->create($type);
+        return $this->queryFactory->create($type, $defaultQuerySettings);
     }
 
     /**
diff -ur private/typo3/sysext/extbase/Classes/Persistence/Generic/QueryFactoryInterface.php patches/extbase/Classes/Persistence/Generic/QueryFactoryInterface.php
--- private/typo3/sysext/extbase/Classes/Persistence/Generic/QueryFactoryInterface.php	2020-07-07 12:02:44.000000000 +0200
+++ patches/extbase/Classes/Persistence/Generic/QueryFactoryInterface.php	2020-07-15 16:19:06.744365294 +0200
@@ -24,7 +24,8 @@
      * Creates a query object working on the given class name
      *
      * @param string $className The class name
+     * @param null|QuerySettingsInterface $defaultQuerySettings
      * @return \TYPO3\CMS\Extbase\Persistence\QueryInterface
      */
-    public function create($className);
+    public function create($className, $defaultQuerySettings = null);
 }
diff -ur private/typo3/sysext/extbase/Classes/Persistence/Generic/QueryFactory.php patches/extbase/Classes/Persistence/Generic/QueryFactory.php
--- private/typo3/sysext/extbase/Classes/Persistence/Generic/QueryFactory.php	2020-07-07 12:02:44.000000000 +0200
+++ patches/extbase/Classes/Persistence/Generic/QueryFactory.php	2020-07-15 16:15:51.580360990 +0200
@@ -62,13 +62,13 @@
      * Creates a query object working on the given class name
      *
      * @param string $className The class name
+     * @param null|QuerySettingsInterface $defaultQuerySettings
      * @return \TYPO3\CMS\Extbase\Persistence\QueryInterface
-     * @throws \TYPO3\CMS\Extbase\Persistence\Generic\Exception
      */
-    public function create($className)
+    public function create($className, $defaultQuerySettings = null)
     {
         $query = $this->objectManager->get(QueryInterface::class, $className);
-        $querySettings = $this->objectManager->get(QuerySettingsInterface::class);
+        $querySettings = $defaultQuerySettings ?? $this->objectManager->get(QuerySettingsInterface::class);
 
         $dataMap = $this->dataMapFactory->buildDataMap($className);
         if ($dataMap->getIsStatic() || $dataMap->getRootLevel()) {
Nur in patches/extbase/Classes/Persistence/Generic: QueryFactory.php.rej.
diff -ur private/typo3/sysext/extbase/Classes/Persistence/PersistenceManagerInterface.php patches/extbase/Classes/Persistence/PersistenceManagerInterface.php
--- private/typo3/sysext/extbase/Classes/Persistence/PersistenceManagerInterface.php	2020-07-07 12:02:44.000000000 +0200
+++ patches/extbase/Classes/Persistence/PersistenceManagerInterface.php	2020-07-15 16:19:06.740365293 +0200
@@ -15,6 +15,8 @@
 
 namespace TYPO3\CMS\Extbase\Persistence;
 
+use TYPO3\CMS\Extbase\Persistence\Generic\QuerySettingsInterface;
+
 /**
  * The Extbase Persistence Manager interface
  */
@@ -144,7 +146,8 @@
      * Return a query object for the given type.
      *
      * @param string $type
+     * @param QuerySettingsInterface $defaultQuerySettings
      * @return QueryInterface
      */
-    public function createQueryForType($type);
+    public function createQueryForType($type, $defaultQuerySettings);
 }
diff -ur private/typo3/sysext/extbase/Classes/Persistence/Repository.php patches/extbase/Classes/Persistence/Repository.php
--- private/typo3/sysext/extbase/Classes/Persistence/Repository.php	2020-07-07 12:02:44.000000000 +0200
+++ patches/extbase/Classes/Persistence/Repository.php	2020-07-15 16:19:06.748365295 +0200
@@ -199,7 +199,7 @@
      */
     public function createQuery()
     {
-        $query = $this->persistenceManager->createQueryForType($this->objectType);
+        $query = $this->persistenceManager->createQueryForType($this->objectType, $this->defaultQuerySettings);
         if ($this->defaultOrderings !== []) {
             $query->setOrderings($this->defaultOrderings);
         }